"use strict";

exports.__esModule = true;
exports.respondOnWebSocket = respondOnWebSocket;

var headerTransforms = _interopRequireWildcard(require("./header-transforms"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

/*eslint-disable no-unused-vars*/

/*eslint-enable no-unused-vars*/
function writeWebSocketHead(socket, destRes, headers) {
  const {
    httpVersion,
    statusCode,
    statusMessage
  } = destRes;
  const resRaw = [`HTTP/${httpVersion} ${statusCode} ${statusMessage}`];
  const headersNames = Object.keys(headers);

  for (const headerName of headersNames) {
    const headerValue = headers[headerName];

    if (Array.isArray(headerValue)) {
      for (const value of headerValue) resRaw.push(headerName + ': ' + value);
    } else resRaw.push(headerName + ': ' + headerValue);
  }

  resRaw.push('', '');
  socket.write(resRaw.join('\r\n'));
}

function respondOnWebSocket(ctx) {
  const headers = headerTransforms.forResponse(ctx);
  const destRes = ctx.destRes;
  writeWebSocketHead(ctx.res, destRes, headers);
  destRes.socket.pipe(ctx.res);
  ctx.res.pipe(destRes.socket);
}